package main

import (
	"fmt"
	"go/ast"
	"go/parser"
	"go/token"
	"os"
	"path"
	"sort"
	"strings"
	"text/template"

	"gitlab.com/art.frela/defimpl/pkg/logging"
	"go.uber.org/zap"
)

var (
	version = "0.0.1"
	logger  *zap.SugaredLogger
)

func main() {
	// validation arguments
	if len(os.Args) < 2 || len(os.Args) > 3 {
		fmt.Println("use defimpl [loglevel: debug|info|warn|error] ./path/to/sourceGoFile.go")
		os.Exit(1)
	}
	fileForParse := ""
	logLevel := "info"
	if len(os.Args) == 2 {
		fileForParse = os.Args[1]
	} else {
		logLevel = os.Args[1]
		fileForParse = os.Args[2]
	}
	logger = logging.New(logLevel, "console")
	// prepare parse file to ast
	fset := token.NewFileSet()
	node, err := parser.ParseFile(fset, fileForParse, nil, parser.ParseComments)
	if err != nil {
		logger.Fatal(err)
	}
	// set output writer
	out, err := makeOutPutFile(fileForParse)
	if err != nil {
		logger.Fatal(err)
	}

	allImports := make(imports, len(node.Imports))
	for i, im := range node.Imports {
		allImports[i] = imp{
			path: im.Path.Value,
		}
		if im.Name != nil {
			allImports[i].name = &im.Name.Name
		}
	}
	logger.Debugf("start defimpl for %s", fileForParse)
	fmt.Fprintln(out, `package `+node.Name.Name)
	fmt.Fprintln(out)
	fmt.Fprintln(out, `// Code generated by defimpl for default implementation of interfaces. DO NOT EDIT.`)
	// fmt.Fprintln(out)
	logger.Debug("allImports:", allImports)
	ifs, resImports := nodeParseInterfaces(node.Decls, nodeParseStructurs(node.Decls), allImports)
	resSliceImports := make([]string, len(resImports))
	i := 0
	for k := range resImports {
		resSliceImports[i] = k
		i++
	}
	sort.Slice(resSliceImports, func(i, j int) bool {
		pre := resSliceImports[i]
		next := resSliceImports[j]
		return pre < next
	})
	if len(resSliceImports) > 0 {
		err = importTmpl.Execute(out, resSliceImports)
		if err != nil {
			logger.Fatalf("make exec imp template error %v", err)
		}
	}

	for _, in := range ifs {
		fmt.Fprintln(out)
		err := defStructTmpl.Execute(out, in)
		if err != nil {
			logger.Fatalf("make defStructTmpl error %v", err)
		}

	}
	logger.Infof("file %s success created", out.Name())
}

var (
	defStructTmpl = template.Must(template.New("defStruct").Parse(`{{$rcv := .Name}}{{$src := .Interface}}// {{.Name}} default implementation of {{$src}}.
type {{.Name}} struct{}
{{range $i, $m := .DefMethods}}
// {{$m.Name}} default implementation method of {{$src}} interface.
func ({{$rcv}}) {{$m.Name}}({{$m.GetArgs}}){{$m.GetResults}} {
	panic("method {{$m.Name}} not yet implemented")
}
{{end}}`))
	importTmpl = template.Must(template.New("import").Parse(`
import ({{range .}}
	{{.}}{{end}}
)
`))
)

type DefStructure struct {
	Name       string
	Interface  string
	DefMethods []Method
}

type Structure struct {
	Name   string
	IsStd  bool
	Fields []Field
}

func (s *Structure) HasFields() bool {
	return len(s.Fields) > 0
}

type Field struct {
	Name      string
	FormName  string
	Rule      string
	FieldType string
}

type Method struct {
	Name    string
	Args    []string
	Results []string
}

type imp struct {
	name *string
	path string
}

func (i imp) string() string {
	if i.name != nil {
		return *i.name + " " + i.path
	}
	return i.path
}

type imports []imp

func (im imports) findImport(name string) string {
	// fmt.Printf("allimports: %+v, find name=%s\n", im, name)
	name = strings.Trim(strings.Trim(name, "*"), "[]")
	name = strings.Trim(strings.Trim(name, "[]"), "*")
	for _, im := range im {
		if im.name != nil {
			if *im.name == name {
				return im.string()
			}
		}
		pname := path.Base(strings.Trim(im.path, `"`))
		if pname == name {
			return im.path
		}
	}
	return ""
}

func (m Method) GetArgs() string {
	return strings.Join(m.Args, ", ")
}

func (m Method) GetResults() string {
	res := " " + strings.Join(m.Results, ", ")
	if len(m.Results) > 1 {
		res = " (" + strings.Join(m.Results, ", ") + ")"
	}
	if len(m.Results) == 0 {
		res = ""
	}
	return res
}

func nodeParseStructurs(decls []ast.Decl) map[string]Structure {
	logger.Debug("start find and process *ast.GenDecl (structures)")
	structs := make(map[string]Structure)
	for _, f := range decls {
		g, ok := f.(*ast.GenDecl)
		if !ok {
			logger.Debugf("SKIP %T is not *ast.GenDecl", f)
			continue
		}
		for _, s := range g.Specs {
			currType, ok := s.(*ast.TypeSpec)
			if !ok {
				logger.Debugf("SKIP %T is not ast.TypeSpec", s)
				continue
			}
			currStruct, ok := currType.Type.(*ast.StructType)
			if !ok {
				logger.Debugf("SKIP %T is not ast.StructType", currStruct)
				continue
			}
			fields := make([]Field, 0, len(currStruct.Fields.List))
			for _, field := range currStruct.Fields.List {
				sField := Field{
					Name:      field.Names[0].String(),
					FieldType: fmt.Sprintf("%v", field.Type),
				}
				fields = append(fields, sField)
			}
			sStruct := Structure{
				Name:   currType.Name.Name,
				Fields: fields,
			}
			structs[currType.Name.Name] = sStruct
		}
	}
	return structs
}

func nodeParseInterfaces(decls []ast.Decl, structs map[string]Structure, allImports imports) (map[string]DefStructure, map[string]string) {
	logger.Debug("START find and process *ast.GenDecl (interfaces)")
	result := make(map[string]DefStructure)
	resImports := make(map[string]string)
	for _, f := range decls {
		g, ok := f.(*ast.GenDecl)
		if !ok {
			logger.Debugf("SKIP %T is not *ast.GenDecl", f)
			continue
		}
		for _, s := range g.Specs {
			currType, ok := s.(*ast.TypeSpec)
			if !ok {
				logger.Debugf("SKIP %T is not ast.TypeSpec", s)
				continue
			}
			curI, ok := currType.Type.(*ast.InterfaceType)
			if !ok {
				logger.Debugf("SKIP %T is not ast.InterfaceType", currType)
				continue
			}
			logger.Debugf("got new interface:%v", currType.Name.Name)
			itemDefStr := DefStructure{
				Name:       makeDefStructName(currType.Name.Name),
				Interface:  currType.Name.Name,
				DefMethods: make([]Method, 0),
			}
		LOOP_METHODS:
			for _, method := range curI.Methods.List {
				if method.Names == nil {
					continue LOOP_METHODS
				}
				logger.Debugf("for Interface=%s found method=%s", currType.Name.Name, method.Names[0].Name)
				itemMeth := Method{
					Name:    method.Names[0].Name,
					Args:    make([]string, 0),
					Results: make([]string, 0),
				}
				if m, ok := method.Type.(*ast.FuncType); ok {
					args, pkgs := getArgsAndPkgs(m.Params.List, structs, allImports)
					logger.Debugf("method %s got parameters: %+v and packages: %+v", method.Names[0].Name, args, pkgs)
					for k, v := range pkgs { // fill imports
						resImports[k] = v
					}
					itemMeth.Args = append(itemMeth.Args, args...)
					logger.Debugf("for Interface=%s.%s find args ended. to find results...", currType.Name.Name, method.Names[0].Name)
					// range results
					if m.Results == nil {
						itemDefStr.DefMethods = append(itemDefStr.DefMethods, itemMeth)
						continue LOOP_METHODS
					}
					ress, pkgs := getArgsAndPkgs(m.Results.List, structs, allImports)
					for k, v := range pkgs { // fill imports
						resImports[k] = v
					}
					itemMeth.Results = append(itemMeth.Results, ress...)
				}
				itemDefStr.DefMethods = append(itemDefStr.DefMethods, itemMeth)
			}
			result[itemDefStr.Name] = itemDefStr
		}
	}
	return result, resImports
}

func makeOutPutFile(src string) (*os.File, error) {
	const suffix string = "_defimpl.go"
	p := path.Base(src)
	d := path.Dir(src)
	fParts := strings.Split(p, ".")
	if len(fParts) != 2 {
		return nil, fmt.Errorf("source filename must me sometext.go")
	}
	fNew := fParts[0] + suffix
	fqdn := path.Join(d, fNew)
	return os.Create(fqdn)
}

func makeDefStructName(iname string) string {
	return "DefImpl" + iname
}

func getArgsAndPkgs(list []*ast.Field, structs map[string]Structure, allImports imports) ([]string, map[string]string) {
	args := make([]string, 0, len(list))
	pkgs := make(map[string]string)
	for _, p := range list {
		arg, pkg := getFieldTypeAndPkg(p, structs, allImports)
		if pkg != "" {
			pkgs[pkg] = pkg
		}
		args = append(args, arg)
		for i := 1; i < len(p.Names); i++ {
			args = append(args, arg)
		}
	}
	return args, pkgs
}

func getFieldTypeAndPkg(p *ast.Field, structs map[string]Structure, allImports imports) (string, string) {
	arg, pkg := "", ""
	if e, ok := p.Type.(*ast.StarExpr); ok { // pointer case
		if arg, ok := structs[fmt.Sprintf("%v", e.X)]; ok {
			return "*" + arg.Name, ""
		}
		arg, pkg = getExpTypeAndPkg(p.Type, allImports)
		return arg, pkg
	}
	if _, ok := p.Type.(*ast.SelectorExpr); ok {
		return getExpTypeAndPkg(p.Type, allImports)
	}
	return getExpTypeAndPkg(p.Type, allImports)
}

func getExpTypeAndPkg(e ast.Expr, allImports imports) (string, string) {
	pkg := ""
	arg, addImp := typeString(e)
	logger.Debugf(">>>>>>>typeString => %s, %t", arg, addImp)
	if addImp {
		clearArg := strings.Trim(arg, ".")

		tss := strings.Split(clearArg, ".")
		pkg = allImports.findImport(tss[0])
		logger.Debugf(">>>>>>>for searchKey=%s, found pkg=%s", tss[0], pkg)
	}
	return arg, pkg
}

func typeString(t ast.Expr) (string, bool) {
	res := ""
	needImport := false
	logger.Debugf(">>>>>>>GOT ast.Expr=%+v typeOf=%T", t, t)
	switch fmt.Sprintf("%T", t) {
	case "*ast.ArrayType":
		ar := t.(*ast.ArrayType)
		v, addimp := typeString(ar.Elt)

		res = fmt.Sprintf("[]%s", v)
		needImport = addimp
	case "*ast.ChanType":
		ch := t.(*ast.ChanType)
		chArr := "chan"
		switch ch.Dir {
		case ast.SEND:
			chArr += "<-"
		case ast.RECV:
			chArr = "<-" + chArr
		}
		value, addImp := typeString(ch.Value)
		// if v, ok := ch.Value.(*ast.StarExpr); ok {
		// 	//fmt.Printf("ChanType.Value is ast.StarExpr: %s *%v\n", chArr, v.X)
		// 	res = fmt.Sprintf("%s *%v", chArr, v.X)
		// } else {
		// 	res = fmt.Sprintf("%s %v", chArr, ch.Value)
		// }
		res = fmt.Sprintf("%s %v", chArr, value)
		needImport = addImp
	case "*ast.Ident":
		res = fmt.Sprintf("%v", t.(*ast.Ident).String())
	case "*ast.InterfaceType":
		res = "interface{}"
	case "*ast.MapType":
		mp := t.(*ast.MapType)
		key, addImp := typeString(mp.Key)
		needImport = addImp
		value, addImp := typeString(mp.Value)
		if !needImport {
			needImport = addImp
		}
		res = fmt.Sprintf("map[%s]%s", key, value)
	case "*ast.StarExpr":
		v := t.(*ast.StarExpr).X
		value, addImp := typeString(v)
		needImport = addImp
		res = "*" + value
	case "*ast.Ellipsis":
		el, addImp := typeString(t.(*ast.Ellipsis).Elt)
		needImport = addImp
		res = "..." + el
	case "*ast.StructType":
		v := t.(*ast.StructType)
		if v.Fields != nil {
			if len(v.Fields.List) == 0 {
				res = "struct{}"
			} else {
				logger.Fatal(">>>>>>>ast.StructType with fields, can't be processed")
			}
		}
	default:
		r := t.(*ast.SelectorExpr)
		logger.Debugf(">>>>>>>default SelectorExpr=%+v", r)
		res = fmt.Sprintf("%s.%s", r.X, r.Sel)
		needImport = true
	}
	logger.Debugf(">>>>>>>res=%s, needImport=%t", res, needImport)
	return res, needImport
}
